"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var SrcdsLogType = require("./SrcdsLog");
var Globals = require("../globals");
(function (ConnectionActions) {
    ConnectionActions[ConnectionActions["Connected"] = 1] = "Connected";
    ConnectionActions[ConnectionActions["Disconnected"] = 2] = "Disconnected";
    ConnectionActions[ConnectionActions["EnteredGame"] = 3] = "EnteredGame";
    ConnectionActions[ConnectionActions["Unknown"] = 4] = "Unknown";
})(exports.ConnectionActions || (exports.ConnectionActions = {}));
var ConnectionActions = exports.ConnectionActions;
var ConnectionType = (function (_super) {
    __extends(ConnectionType, _super);
    function ConnectionType(time, data) {
        _super.call(this, time);
        this.Player = new Globals.Player(data[1]);
        switch (data[2]) {
            case 'connected':
                this.Address = data[3];
                this.Action = ConnectionActions.Connected;
                break;
            case 'disconnected':
                this.Reason = data[3];
                this.Action = ConnectionActions.Disconnected;
                break;
            case 'entered':
                this.Action = ConnectionActions.EnteredGame;
                break;
        }
        this.Type = "Connection";
    }
    ConnectionType.Identifier = [
        {
            regex: new RegExp(/^/.source + Globals.SteamIdRegex.source + / (connected), address "(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})?"$/.source)
        },
        {
            regex: new RegExp(/^/.source + Globals.SteamIdRegex.source + / (disconnected) \(reason "(.+)"\)$/.source)
        },
        {
            regex: new RegExp(/^/.source + Globals.SteamIdRegex.source + / (entered) the game$/.source)
        }];
    return ConnectionType;
}(SrcdsLogType.SrcdsLog));
exports.ConnectionType = ConnectionType;
//# sourceMappingURL=ConnectionType.js.map