"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var SrcdsLogType = require("./SrcdsLog");
var Globals = require("../globals");
(function (PlayerTriggerType) {
    PlayerTriggerType[PlayerTriggerType["Begin_Bomb_Defuse_Without_Kit"] = 0] = "Begin_Bomb_Defuse_Without_Kit";
    PlayerTriggerType[PlayerTriggerType["Begin_Bomb_Defuse_With_Kit"] = 1] = "Begin_Bomb_Defuse_With_Kit";
    PlayerTriggerType[PlayerTriggerType["Defused_The_Bomb"] = 2] = "Defused_The_Bomb";
    PlayerTriggerType[PlayerTriggerType["Planted_The_Bomb"] = 3] = "Planted_The_Bomb";
    PlayerTriggerType[PlayerTriggerType["Round_End"] = 4] = "Round_End";
    PlayerTriggerType[PlayerTriggerType["Got_The_Bomb"] = 5] = "Got_The_Bomb";
    PlayerTriggerType[PlayerTriggerType["Dropped_The_Bomb"] = 6] = "Dropped_The_Bomb";
    PlayerTriggerType[PlayerTriggerType["Game_Commencing"] = 7] = "Game_Commencing";
    PlayerTriggerType[PlayerTriggerType["Round_Start"] = 8] = "Round_Start";
    PlayerTriggerType[PlayerTriggerType["Match_Start"] = 9] = "Match_Start";
    PlayerTriggerType[PlayerTriggerType["Restart_Round_1_second"] = 10] = "Restart_Round_1_second";
    PlayerTriggerType[PlayerTriggerType["Restart_Round_3_seconds"] = 11] = "Restart_Round_3_seconds";
    PlayerTriggerType[PlayerTriggerType["clantag"] = 12] = "clantag";
    PlayerTriggerType[PlayerTriggerType["Unknown"] = 13] = "Unknown";
})(exports.PlayerTriggerType || (exports.PlayerTriggerType = {}));
var PlayerTriggerType = exports.PlayerTriggerType;
var PlayerTriggeredType = (function (_super) {
    __extends(PlayerTriggeredType, _super);
    function PlayerTriggeredType(time, data) {
        _super.call(this, time);
        this.Type = "PlayerTriggered";
        this.Player = new Globals.Player(data[1]);
        var eventType = data[2];
        this.Value = data[3];
        switch (eventType) {
            case 'Begin_Bomb_Defuse_Without_Kit':
                this.EventType = PlayerTriggerType.Begin_Bomb_Defuse_Without_Kit;
                break;
            case 'Begin_Bomb_Defuse_With_Kit':
                this.EventType = PlayerTriggerType.Begin_Bomb_Defuse_With_Kit;
                break;
            case 'Defused_The_Bomb':
                this.EventType = PlayerTriggerType.Defused_The_Bomb;
                break;
            case 'Planted_The_Bomb':
                this.EventType = PlayerTriggerType.Planted_The_Bomb;
                break;
            case 'Round_End':
                this.EventType = PlayerTriggerType.Round_End;
                break;
            case 'Got_The_Bomb':
                this.EventType = PlayerTriggerType.Got_The_Bomb;
                break;
            case 'Dropped_The_Bomb':
                this.EventType = PlayerTriggerType.Dropped_The_Bomb;
                break;
            case 'Game_Commencing':
                this.EventType = PlayerTriggerType.Game_Commencing;
                break;
            case 'Round_Start':
                this.EventType = PlayerTriggerType.Round_Start;
                break;
            case 'Match_Start':
                this.EventType = PlayerTriggerType.Match_Start;
                break;
            case 'Restart_Round_(1_second)':
                this.EventType = PlayerTriggerType.Restart_Round_1_second;
                break;
            case 'Restart_Round_(3_seconds)':
                this.EventType = PlayerTriggerType.Restart_Round_3_seconds;
                break;
            case 'clantag':
                this.EventType = PlayerTriggerType.clantag;
                break;
            default:
                this.EventType = PlayerTriggerType.Unknown;
                console.error("Unknown player trigger event type: ", eventType);
                break;
        }
    }
    PlayerTriggeredType.Identifier = [{
            regex: new RegExp(/^/.source + Globals.SteamIdRegex.source + / triggered "(\S+)"(?: \(value "(.*)"\))?$/.source)
        },
        {
            regex: new RegExp(/^/.source + Globals.SteamIdRegex.source + / triggered "(\S+)" on "(\S+)"$/.source)
        }];
    return PlayerTriggeredType;
}(SrcdsLogType.SrcdsLog));
exports.PlayerTriggeredType = PlayerTriggeredType;
//# sourceMappingURL=PlayerTriggeredType.js.map