"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var SrcdsLogType = require("./SrcdsLog");
(function (ServerEvents) {
    ServerEvents[ServerEvents["MapLoading"] = 1] = "MapLoading";
    ServerEvents[ServerEvents["MapStarted"] = 2] = "MapStarted";
    ServerEvents[ServerEvents["LogFileOpened"] = 3] = "LogFileOpened";
    ServerEvents[ServerEvents["LogFileClosed"] = 4] = "LogFileClosed";
    ServerEvents[ServerEvents["ServerMessage"] = 5] = "ServerMessage";
    ServerEvents[ServerEvents["Unknown"] = 6] = "Unknown";
})(exports.ServerEvents || (exports.ServerEvents = {}));
var ServerEvents = exports.ServerEvents;
var ServerEventType = (function (_super) {
    __extends(ServerEventType, _super);
    function ServerEventType(time, data, extraArg) {
        _super.call(this, time);
        this.Type = "ServerEvent";
        switch (extraArg) {
            case 'loadingmap':
                this.EventType = data[1] == 'Loading' ? ServerEvents.MapLoading : ServerEvents.MapStarted;
                this.Data = {
                    Map: data[2],
                    CRC: data[3]
                };
                break;
            case 'logopen':
                this.EventType = ServerEvents.LogFileOpened;
                this.Data = {
                    file: data[1],
                    game: data[2],
                    version: data[3]
                };
                break;
            case 'logclosed':
                this.EventType = ServerEvents.LogFileClosed;
                break;
            case 'server_message':
                this.EventType = ServerEvents.ServerMessage;
                this.Data = data[1];
                break;
            default: throw "invalid extraArg supplied to ServerEventType - " + extraArg;
        }
    }
    ServerEventType.Identifier = [{
            regex: /^(Loading|Started) map "(.+)"(?: \(CRC "([-\d]+)"\))?$/,
            extraArg: 'loadingmap'
        }, {
            regex: /^Log file started \(file "(\S+)"\) \(game "(\S+)"\) \(version "(\S+)"\)$/,
            extraArg: 'logopen'
        }, {
            regex: /^Log file closed$/,
            extraArg: 'logclosed'
        }, {
            regex: /^server_message: "(.+)"$/,
            extraArg: 'server_message'
        },
    ];
    return ServerEventType;
}(SrcdsLogType.SrcdsLog));
exports.ServerEventType = ServerEventType;
//# sourceMappingURL=ServerEventType.js.map