"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var SrcdsLogType = require("./SrcdsLog");
var Globals = require("../globals");
(function (TeamTriggerType) {
    TeamTriggerType[TeamTriggerType["SFUI_Notice_Terrorists_Win"] = 1] = "SFUI_Notice_Terrorists_Win";
    TeamTriggerType[TeamTriggerType["SFUI_Notice_CTs_Win"] = 2] = "SFUI_Notice_CTs_Win";
    TeamTriggerType[TeamTriggerType["SFUI_Notice_Target_Bombed"] = 3] = "SFUI_Notice_Target_Bombed";
    TeamTriggerType[TeamTriggerType["SFUI_Notice_Target_Saved"] = 4] = "SFUI_Notice_Target_Saved";
    TeamTriggerType[TeamTriggerType["SFUI_Notice_Bomb_Defused"] = 5] = "SFUI_Notice_Bomb_Defused";
    TeamTriggerType[TeamTriggerType["Unknown"] = -1] = "Unknown";
})(exports.TeamTriggerType || (exports.TeamTriggerType = {}));
var TeamTriggerType = exports.TeamTriggerType;
var TeamTriggeredType = (function (_super) {
    __extends(TeamTriggeredType, _super);
    function TeamTriggeredType(time, data) {
        _super.call(this, time);
        this.Type = "TeamTriggered";
        var eventType;
        this.Team = Globals.getTeam(data[1]);
        eventType = data[2];
        this.TerroristScore = parseInt(data[4]);
        this.CounterTerroristScore = parseInt(data[3]);
        switch (eventType) {
            case 'SFUI_Notice_Terrorists_Win':
                this.EventType = TeamTriggerType.SFUI_Notice_Terrorists_Win;
                break;
            case 'SFUI_Notice_CTs_Win':
                this.EventType = TeamTriggerType.SFUI_Notice_CTs_Win;
                break;
            case 'SFUI_Notice_Target_Bombed':
                this.EventType = TeamTriggerType.SFUI_Notice_Target_Bombed;
                break;
            case 'SFUI_Notice_Target_Saved':
                this.EventType = TeamTriggerType.SFUI_Notice_Target_Saved;
                break;
            case 'SFUI_Notice_Bomb_Defused':
                this.EventType = TeamTriggerType.SFUI_Notice_Bomb_Defused;
                break;
            default:
                this.EventType = TeamTriggerType.Unknown;
                console.error("Unknown team trigger event type: ", eventType);
                break;
        }
    }
    TeamTriggeredType.Identifier = {
        regex: new RegExp("^Team " + Globals.TeamRegex.source + / triggered "(\S+)" \(CT "(\d+)"\) \(T "(\d+)"\)$/.source)
    };
    return TeamTriggeredType;
}(SrcdsLogType.SrcdsLog));
exports.TeamTriggeredType = TeamTriggeredType;
//# sourceMappingURL=TeamTriggeredType.js.map